#include <iostream>

using namespace std;
int n,m,t;

int main()
{
    scanf("%d",&t);

    scanf("%d%d",&n,&m);
    int l[n][m];

    for(int i=0;i<n*t;i++)
        for(int j=0;j<m;j++)
         scanf("%d",&l[i][j]);

    pair<int,int>u;
   scanf("%d%d",&n,&m);
   printf("DA\n");
   for(int i=0;i<n*t;i++)
       {

         scanf("%d%d",&u.first ,&u.second);
         for(int i=0;i<n*t;i++)
          {

          if(u.second + u.first == abs(l[i][1]) - l[i][0])
           {
               printf("%d %d \n",l[i][0],l[i][1]); break;
           }
           }

       }
    printf("NE\n");




    return 0;
}